/*$Id: main.c 360 2009-01-12 07:48:08Z wenbin $*/

/*
# Copyright (c) 2008, Wenbin Fang (wenbin@cse.ust.hk), HKUST, Hong Kong
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the HKUST nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY  ''AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Wenbin Fang BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "MarsCPU.h"

void *rec_print(gpointer key, gsize keysize, gpointer val, gsize valsize, gsize recnum, gpointer arg)
{
    g_debug("%f, %f", *(gfloat*)key, *(gfloat*)val);
}

int main(int argc, char** argv)
{
    if (argc < 2)
    {
        g_print("usage: %s filename\n", argv[0]);
        exit(0);
    }

    Timer_t alltimer;
    cpu_start_timer(&alltimer);

    gchar* filename = argv[1];
    gchar* content = NULL;
    gsize length = 0;

    Timer_t timer  ;
    cpu_start_timer(&timer);
    if (!g_file_get_contents(filename, &content, &length, NULL))
         g_error("failed to get file content!");
    cpu_stop_timer("i/o", &timer);
  
    gsize num_option = length / sizeof(gfloat) / 6;

    g_debug("num_option:%d", num_option);
    Spec_t* spec = MarsSpecNew();
    spec->workflow = MAP_ONLY;

    cpu_start_timer(&timer);
    guint32 i;
    gfloat* data = (gfloat*)content;

    for (i = 0; i < num_option; i++)
    {
        guint32 offset = i * 6;
        MarsAddInputRec(spec, &offset, sizeof(guint32), &data, sizeof(gpointer));
    }
    cpu_stop_timer("preprocess", &timer);

    MarsSchedule(spec);
    //MarsProcessRec(spec, OUT_REC, 1000, rec_print, NULL);
    g_free(content);
    MarsFinish(&spec);
    cpu_stop_timer("all", &alltimer);

    return 0;
}
