#! /bin/sh

#$Id: sync.sh 341 2009-01-09 04:06:51Z wenbin $
#synchonize common files between applications

# Copyright (c) 2008, Wenbin Fang (wenbin@cse.ust.hk), HKUST, Hong Kong
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the HKUST nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY  ''AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Wenbin Fang BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

CURRENT_DIR='Phoenix'
FILE1='sync.sh'
FILE2='MapReduceScheduler.c'
FILE3='MapReduceScheduler.h'
FILE4='Makefile'
COMMON_PATH='../../../common'

sh $COMMON_PATH/inc.sh

function sync_copy
{
  for app_dir in ../../../app/*
  do
      if [ -d $app_dir ]; then
          dest="$app_dir/$CURRENT_DIR/$1"
          echo "synchronizing $dest"
          if ! [ $dest -ef $1 ]; then
              cp -f -r $1 $dest
          fi
      fi
  done
}

sync_copy $FILE1
sync_copy $FILE2
sync_copy $FILE3
#sync_copy $FILE4
echo "done"
