/*Id*/

/*
# Copyright (c) 2008, Wenbin Fang (wenbin@cse.ust.hk), HKUST, Hong Kong
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the HKUST nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY  ''AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Wenbin Fang BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
#include "global.h"

void map_count_func(
                   gpointer   key,
                   gpointer   val,
                   gsize      keySize,
                   gsize      valSize,

                   MapCount_t* mc
                    )
{
    if (keySize == sizeof(gpointer))
        emit_inter_count(sizeof(guint32), sizeof(guint32), mc);
    else
        emit_inter_count(sizeof(guint32)*2, sizeof(guint32), mc);
}

void map_func(
             gpointer key,
             gpointer val,
             gsize    keySize,
             gsize    valSize,

             Map_t* m
             )
{
    if (keySize == sizeof(gpointer))
    {
        guint32* matrix = *(guint32**)key;
        info_t* info = (info_t*)val;
        guint32* row = matrix + info->row_id * info->col_num;

        guint mean = 0;
        guint i;
        for (i = 0; i < info->col_num; i++)
            mean += row[i];
        mean /= info->col_num;

        //g_debug("pos1:%d, mean:%d", info->row_id, mean);
        emit_inter(&info->row_id, sizeof(guint32), &mean, sizeof(guint32), m);
    }
    else
    {
        info2_t* info = (info2_t*)key;
        guint32* matrix = *(guint32**)val;
        guint32* row1 = (guint32*)matrix + info->row1_id * info->col_num;
        guint32* row2 = (guint32*)matrix + info->row2_id * info->col_num;
        //g_debug("row1:%d, mean:%d, row2:%d, mean:%d",
//          info->row1_id, info->row1_mean, info->row2_id, info->row2_mean);
        
        guint32 covariance = 0;
        guint32 i;
        for (i = 0; i < info->col_num; i++)
            covariance += (row1[i]-info->row1_mean) * (row2[i]-info->row2_mean);
        covariance /= info->col_num;

        //g_debug("covariance:%d", covariance);
        emit_inter(key, sizeof(guint32)*2, &covariance, sizeof(guint32), m);
    }
}
