/*$Id: reduce.c 375 2009-01-14 11:23:36Z wenbin $*/

/*
# Copyright (c) 2008, Wenbin Fang (wenbin@cse.ust.hk), HKUST, Hong Kong
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the HKUST nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY  ''AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Wenbin Fang BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


void reduce_count_func(
                   gpointer   key,
                   gpointer   vals,
                   gsize      keySize,
                   gsize      valNum,
                  
                   MapCount_t* mc,
                   guint32 gindex
                    )
{
   //guint32 color = *(guint32*)key;
   //g_debug("%d", color);
   emit_inter_count(sizeof(guint32), sizeof(guint32), mc);
}

void reduce_func(
             gpointer key,
             gpointer vals,
             gsize    keySize,
             gsize    valNum,

             Map_t* m, 
             guint32 gindex
             )
{
   guint32 color = *(guint32*)key;
   //g_debug("color:%d, valNum:%d", color, valNum);

   guint32 sum = 0;
   guint32 i;
   for (i = 0; i < valNum; i++)
   {
       guint32 count = *(guint32*)GetReduceVal(vals, m->input_index, m->input_group_index, gindex, i);
       sum+= count;
   }
   emit_inter(key, keySize, &sum, sizeof(guint32), m);
}
